# Summary

* [Introduction](README.md)
* [Quickstart](quickstart.md)
* [Installation]()
    * [Linux](installation/install.md)
    * [MacOS](installation/macos.md)
    * [Windows](installation/windows.md)
* [Configuration](configure.md)
    * [oidc-agent Directory](configuration/directory.md)
    * [Set Default Account for a Provider](configuration/default-accounts.md)
    * [oidc-agent Integration](configuration/integration.md)
    * [Agent Forwarding](configuration/forwarding.md)
    * [Other Configuration](configuration/other.md)
* [Usage](user.md)
    * [oidc-agent](oidc-agent/oidc-agent.md)
        * [Starting oidc-agent](oidc-agent/start.md)
        * [General Usage](oidc-agent/general.md)
        * [Detailed Information About All Options](oidc-agent/options.md)
    * [oidc-agent-service](oidc-agent-service/oidc-agent-service.md)
    * [oidc-keychain](oidc-keychain/oidc-keychain.md)
        * [General Usage](oidc-keychain/general.md)
        * [Detailed Information About All Options](oidc-keychain/options.md)
    * [oidc-gen](oidc-gen/oidc-gen.md)
        * [General Usage](oidc-gen/general.md)
        * [Detailed Information About All Options](oidc-gen/options.md)
        * [Integrate With Different Providers](provider/provider.md)
            * [B2Access](provider/b2access.md)
            <!-- * [EduTeams](provider/eduteams.md) -->
            * [EGI](provider/egi.md)
            * [Elixir](provider/elixir.md)
            * [Google](provider/google.md)
            * [HBP](provider/hbp.md)
            * [Helmholtz AAI](provider/helmholtz.md)
            * [IAM (INDIGO/DEEP)](provider/iam.md)
            * [KIT](provider/kit.md)
            * [Any Other Provider](provider/general.md)
            * [Known Issues](provider/known-issues.md)
            * [Client Configuration Values](provider/client-configuration-values.md)
    * [oidc-add](oidc-add/oidc-add.md)
        * [General Usage](oidc-add/general.md)
        * [Detailed Information About All Options](oidc-add/options.md)
    * [oidc-token](oidc-token/oidc-token.md)
        * [General Usage](oidc-token/general.md)
        * [Detailed Information About All Options](oidc-token/options.md)
    * [Other Applications Using oidc-agent](agent-clients.md)
    * [Tips](tips.md)
    * [oidc-agent-server](oidc-agent-server/oidc-agent-server.md)
* [Windows](windows/windows.md)
    * [Installation](windows/installation.md)
* [MAC OS](macos/macos.md)
    * [State of Feature Support](macos/state.md)
    * [Installation](macos/installation.md)
* [Security]()
    * [Privilege Separation & Architecture](security/privilege-separation.md)
    * [Account Configuration Files](security/account-configs.md)
    * [Credentials](security/credentials.md)
    * [Memory](security/memory.md)
    * [Agent Locking](security/agent-locking.md)
    * [Communication](security/communication.md)
    * [Encryption Passwords](security/encryption-passwords.md)
    * [Autounload (Lifetime)](security/autounload.md)
    * [User Confirmation](security/confirmation.md)
    * [Tracing](security/tracing.md)
    * [seccomp](security/seccomp.md)
    * [Final Note](security/final.md)
* [API](api/api.md)
    * [liboidc-agent4](api/api-c.md)
    * [liboidcagent-go](api/api-go.md)
    * [liboidcagent-py](api/api-py.md)
    * [IPC-API](api/api-ipc.md)
